---
title: WindowEventHandlers.onbeforeprint
slug: Web/API/WindowEventHandlers/onbeforeprint
tags:
  - API
  - Event Handler
  - HTML DOM
  - Property
  - Reference
  - Wiindow
  - printing
---
<div>{{ApiRef}}</div>

<p>The <code><strong>onbeforeprint</strong></code> property of the {{domxref("WindowEventHandlers")}} mixin is the {{domxref("EventHandler")}} for processing {{event("beforeprint")}} events for the current window. These events are raised before the print dialog window is opened.</p>

<p>The <code>beforeprint</code> and {{event("afterprint")}} events allow pages to change their content before printing starts (perhaps to remove a banner, for example) and then revert those changes after printing has completed. In general, you should prefer the use of an <code><a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#Media_types">@media print</a></code> CSS at-rule, but it may be necessary to use these events in some cases.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">window.addEventListener("beforeprint", function(event) { ... });
window.onbeforeprint = function(event) { ... };
</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>Safari does not implement these events, but you can create an equivalent result to the <code>beforeprint</code> event with {{domxref("window.matchMedia")}}<code>('print')</code>.</p>

<pre class="brush: js">var mediaQueryList = window.matchMedia('print');
mediaQueryList.addListener(function(mql) {
  if(mql.matches) {
    console.log('webkit equivalent of onbeforeprint');
  }
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#handler-window-onbeforeprint', 'onbeforeprint')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WindowEventHandlers.onbeforeprint")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Window.print()")}}</li>
 <li>{{domxref("WindowEventHandlers.onafterprint")}}</li>
 <li><a href="/en-US/docs/Web/Guide/Printing">Printing</a></li>
</ul>
